Loading...
Searching...
No Matches
BALL::VIEW::PubChemDialog Class Reference

`#include <BALL/VIEW/DIALOGS/pubchemDialog.h>`

Inheritance diagram for BALL::VIEW::PubChemDialog:

## Classes

struct | ParsedResult_

## Public Slots

void | show ()
| Show and raise dialog.
void | generateButtonClicked ()
| Generate a structure from SMILES.
void | queryPubChem ()
| Query PubChem.
void | switchView (QTreeWidgetItem *item, int column)
void | clearEntries ()
void | finished ()
void | updateDownloadProgress (qint64 done, qint64 total)
void | downloadFinished (QNetworkReply *reply)

## Public Member Functions

| PubChemDialog (QWidget *parent=NULL, const char *name="PubChemDialog")
| Default Constructor.
virtual | ~PubChemDialog ()
| Destructor.
virtual void | initializeWidget (MainControl &main_control)
virtual void | checkMenu (MainControl &main_control)
void | generateFromSMILES (const String &SMILES)
Public Member Functions inherited from BALL::VIEW::ModularWidget
| ModularWidget (const char *name="<ModularWidget>")
| ModularWidget (const ModularWidget &widget)
virtual | ~ModularWidget ()
virtual void | destroy ()
virtual void | clear ()
QAction * | insertMenuEntry (Position parent_id, const QString &name, const QObject *receiver=0, const char *slot=0, const String &description="", QKeySequence accel=QKeySequence(), const QString &menu_hint=QString(""), UIOperationMode::OperationMode minimal_mode=UIOperationMode::MODE_ALL)
BALL_DEPRECATED void | setMenuHelp (QAction *, const String &)
virtual BALL_DEPRECATED void | registerForHelpSystem (const QObject *, const String &)
virtual void | addToolBarEntries (QToolBar *main_tb)
void | setIcon (QAction *action, const String &filename, bool add_to_main_toolbar=true)
virtual void | initializePreferencesTab (Preferences &preferences)
virtual void | finalizePreferencesTab (Preferences &preferences)
virtual void | applyPreferences ()
virtual void | fetchPreferences (INIFile &inifile)
virtual void | writePreferences (INIFile &inifile)
bool | lockComposites ()
bool | unlockComposites ()
| Unlock the Composites.
MainControl * | getMainControl () const
virtual void | setStatusbarText (const String &text, bool important=false)
virtual void | setStatusbarText (const QString &text, bool important=false)
String | getWorkingDir ()
| Implemented for convenience.
void | setWorkingDir (const String &dir)
| Implemented for convenience.
FragmentDB & | getFragmentDB () const
virtual void | dump (std::ostream &s=std::cout, Size depth=0) const
void | setWorkingDirFromFilename_ (String filename)
virtual BALL_DEPRECATED void | showHelp (const String &)
virtual void | finalizeWidget (MainControl &main_control)
virtual bool | canHandle (const String &) const
virtual bool | openFile (const String &)
Public Member Functions inherited from BALL::Embeddable
| Embeddable (const String &identifier="<Embeddable>")
| Embeddable (const Embeddable &embeddable)
virtual | ~Embeddable ()
void | setIdentifier (const String &identifier)
const String & | getIdentifier () const
void | unregisterThis ()
virtual void | registerThis ()
Public Member Functions inherited from BALL::VIEW::ConnectionObject
| ConnectionObject ()
virtual | ~ConnectionObject ()
void | registerConnectionObject (ConnectionObject &object)
void | unregisterConnectionObject (ConnectionObject &object)
bool | isConnectionObjectRegistered (const ConnectionObject &object)
ConnectionObject * | getParent () const
ConnectionObject * | getRoot ()
virtual void | onNotify (Message *message)
virtual bool | isValid () const

## Protected Types

enum | InfoDisplayStyle { LONG , SHORT }

## Protected Member Functions

void | insert_ (ParsedResult_ d, QTreeWidgetItem *parent, bool plot)
bool | handleDownloadError_ (QNetworkReply *reply)
void | buildInformationTemplates_ ()
QString | buildHeaderTemplate_ (InfoDisplayStyle style, const char *str) const
void | notify_ (Message *message)
void | notify_ (Message &message)
void | onNotify_ (Message *message)

## Protected Attributes

Ui::PubChemDialogData * | ui_
SmilesParser | smiles_parser_
std::map< QTreeWidgetItem *, System * > | sd_systems_
std::map< QTreeWidgetItem *, System * > | original_systems_
std::map< QTreeWidgetItem *, ParsedResult_ > | descriptions_
QAction * | action1_
QAction * | action2_
HashMap< int, QTreeWidgetItem * > | esummary_request_ids_
boost::unordered_map< String, QString > | information_templates_
QPushButton * | add_button_
QNetworkAccessManager * | network_manager_
QAction * | window_menu_entry_
bool | show_window_enty_
bool | default_visible_
QList< QAction * > | main_toolbar_actions_

## Additional Inherited Members

Public Types inherited from BALL::Embeddable
typedef std::vector< Embeddable * > | EmbeddableVector
static void | registerWidget (ModularWidget *mwidget)
static void | registerInstance_ (const std::type_info &type, const Embeddable *instance)
static void | unregisterInstance_ (const Embeddable *instance)
static Size | countInstances_ (const std::type_info &type)
static Embeddable * | getInstance_ (const std::type_info &type, Position index)
static Embeddable * | getInstance_ (const std::type_info &type, const String &identifier)

## Detailed Description

Dialog for querying PubChem and generating structures from a SMILES string

Definition at line 41 of file pubchemDialog.h.

## Member Enumeration Documentation

## InfoDisplayStyle

enum BALL::VIEW::PubChemDialog::InfoDisplayStyle

protected

Enumerator
LONG |
SHORT |

Definition at line 103 of file pubchemDialog.h.

## Constructor & Destructor Documentation

## PubChemDialog()

BALL::VIEW::PubChemDialog::PubChemDialog | ( | QWidget * | parent = NULL,
|  | const char * | name = "PubChemDialog" )

Default Constructor.

## ~PubChemDialog()

virtual BALL::VIEW::PubChemDialog::~PubChemDialog | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## buildHeaderTemplate_()

QString BALL::VIEW::PubChemDialog::buildHeaderTemplate_ | ( | InfoDisplayStyle | style,
|  | const char * | str ) const

protected

## buildInformationTemplates_()

void BALL::VIEW::PubChemDialog::buildInformationTemplates_ | ( |  | ) |

protected

## checkMenu()

virtual void BALL::VIEW::PubChemDialog::checkMenu | ( | MainControl & | main_control | ) |

virtual

Menu checking method. This method is called MainControl::checkMenus before a popup menu is shown. It should be used to update the state of menu entries (e.g. disable or enable entries).

Parameters

  main_control | the MainControl object whose menus should be checked

Reimplemented from BALL::VIEW::ModularWidget.

## clearEntries

void BALL::VIEW::PubChemDialog::clearEntries | ( |  | ) |

slot

## downloadFinished

void BALL::VIEW::PubChemDialog::downloadFinished | ( | QNetworkReply * | reply | ) |

slot

## finished

void BALL::VIEW::PubChemDialog::finished | ( |  | ) |

slot

## generateButtonClicked

void BALL::VIEW::PubChemDialog::generateButtonClicked | ( |  | ) |

slot

Generate a structure from SMILES.

## generateFromSMILES()

void BALL::VIEW::PubChemDialog::generateFromSMILES | ( | const String & | SMILES | ) |

## handleDownloadError_()

bool BALL::VIEW::PubChemDialog::handleDownloadError_ | ( | QNetworkReply * | reply | ) |

protected

## initializeWidget()

virtual void BALL::VIEW::PubChemDialog::initializeWidget | ( | MainControl & | main_control | ) |

virtual

Initialize the widget. This method is called automatically immediately before the main application is started. It should add the widget's menu entries and connections (if required). This method will be called by MainControl::show.

Parameters

  main_control | the MainControl object to be initialized with this ModularWidget

See also
  finalizeWidget()

Reimplemented from BALL::VIEW::ModularWidget.

## insert_()

void BALL::VIEW::PubChemDialog::insert_ | ( | ParsedResult_ | d,
|  | QTreeWidgetItem * | parent,
|  | bool | plot )

protected

## queryPubChem

void BALL::VIEW::PubChemDialog::queryPubChem | ( |  | ) |

slot

Query PubChem.

## show

void BALL::VIEW::PubChemDialog::show | ( |  | ) |

slot

Show and raise dialog.

## switchView

void BALL::VIEW::PubChemDialog::switchView | ( | QTreeWidgetItem * | item,
|  | int | column )

slot

## updateDownloadProgress

void BALL::VIEW::PubChemDialog::updateDownloadProgress | ( | qint64 | done,
|  | qint64 | total )

slot

## Member Data Documentation

## action1_

QAction* BALL::VIEW::PubChemDialog::action1_

protected

Definition at line 116 of file pubchemDialog.h.

## action2_

QAction * BALL::VIEW::PubChemDialog::action2_

protected

Definition at line 116 of file pubchemDialog.h.

## add_button_

QPushButton* BALL::VIEW::PubChemDialog::add_button_

protected

Definition at line 121 of file pubchemDialog.h.

## descriptions_

std::map<QTreeWidgetItem*, ParsedResult_> BALL::VIEW::PubChemDialog::descriptions_

protected

Definition at line 114 of file pubchemDialog.h.

## esummary_request_ids_

HashMap<int, QTreeWidgetItem*> BALL::VIEW::PubChemDialog::esummary_request_ids_

protected

Definition at line 118 of file pubchemDialog.h.

## information_templates_

boost::unordered_map<String, QString> BALL::VIEW::PubChemDialog::information_templates_

protected

Definition at line 119 of file pubchemDialog.h.

## network_manager_

QNetworkAccessManager* BALL::VIEW::PubChemDialog::network_manager_

protected

Definition at line 122 of file pubchemDialog.h.

## original_systems_

std::map<QTreeWidgetItem*, System*> BALL::VIEW::PubChemDialog::original_systems_

protected

Definition at line 113 of file pubchemDialog.h.

## sd_systems_

std::map<QTreeWidgetItem*, System*> BALL::VIEW::PubChemDialog::sd_systems_

protected

Definition at line 112 of file pubchemDialog.h.

## smiles_parser_

SmilesParser BALL::VIEW::PubChemDialog::smiles_parser_

protected

Definition at line 94 of file pubchemDialog.h.

## ui_

Ui::PubChemDialogData* BALL::VIEW::PubChemDialog::ui_

protected

Definition at line 92 of file pubchemDialog.h.